diff -ru old/ftgl-2.1.3~rc5/src/FTFont/FTBufferFont.cpp ftgl-2.1.3~rc5/src/FTFont/FTBufferFont.cpp
--- old/ftgl-2.1.3~rc5/src/FTFont/FTBufferFont.cpp	2008-06-12 12:52:03.000000000 +0300
+++ ftgl-2.1.3~rc5/src/FTFont/FTBufferFont.cpp	2018-08-02 08:44:37.691414818 +0300
@@ -238,7 +238,6 @@
 
     glEnable(GL_BLEND);
     glEnable(GL_TEXTURE_2D);
-    glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA); // GL_ONE
 
     // Search whether the string is already in a texture we uploaded
     for(int n = 0; n < BUFFER_CACHE_SIZE; n++)
diff -ru old/ftgl-2.1.3~rc5/src/FTFont/FTOutlineFont.cpp ftgl-2.1.3~rc5/src/FTFont/FTOutlineFont.cpp
--- old/ftgl-2.1.3~rc5/src/FTFont/FTOutlineFont.cpp	2008-06-09 15:52:07.000000000 +0300
+++ ftgl-2.1.3~rc5/src/FTFont/FTOutlineFont.cpp	2018-08-02 08:44:24.398329513 +0300
@@ -101,7 +101,6 @@
     glEnable(GL_LINE_SMOOTH);
     glHint(GL_LINE_SMOOTH_HINT, GL_DONT_CARE);
     glEnable(GL_BLEND);
-    glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA); // GL_ONE
 
     FTPoint tmp = FTFontImpl::Render(string, len,
                                      position, spacing, renderMode);
diff -ru old/ftgl-2.1.3~rc5/src/FTFont/FTPixmapFont.cpp ftgl-2.1.3~rc5/src/FTFont/FTPixmapFont.cpp
--- old/ftgl-2.1.3~rc5/src/FTFont/FTPixmapFont.cpp	2008-06-09 15:52:09.000000000 +0300
+++ ftgl-2.1.3~rc5/src/FTFont/FTPixmapFont.cpp	2018-08-02 08:44:31.750376686 +0300
@@ -92,7 +92,6 @@
     glPushClientAttrib(GL_CLIENT_PIXEL_STORE_BIT);
 
     glEnable(GL_BLEND);
-    glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
 
     glDisable(GL_TEXTURE_2D);
 
diff -ru old/ftgl-2.1.3~rc5/src/FTFont/FTTextureFont.cpp ftgl-2.1.3~rc5/src/FTFont/FTTextureFont.cpp
--- old/ftgl-2.1.3~rc5/src/FTFont/FTTextureFont.cpp	2008-06-09 15:52:12.000000000 +0300
+++ ftgl-2.1.3~rc5/src/FTFont/FTTextureFont.cpp	2018-08-02 08:42:10.248622042 +0300
@@ -235,7 +235,6 @@
     glPushAttrib(GL_ENABLE_BIT | GL_COLOR_BUFFER_BIT);
 
     glEnable(GL_BLEND);
-    glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA); // GL_ONE
 
     glEnable(GL_TEXTURE_2D);
 
diff -ru old/ftgl-2.1.3~rc5/src/FTGlyph/FTPixmapGlyph.cpp ftgl-2.1.3~rc5/src/FTGlyph/FTPixmapGlyph.cpp
--- old/ftgl-2.1.3~rc5/src/FTGlyph/FTPixmapGlyph.cpp	2008-06-09 15:52:35.000000000 +0300
+++ ftgl-2.1.3~rc5/src/FTGlyph/FTPixmapGlyph.cpp	2018-08-02 08:41:44.171453065 +0300
@@ -91,6 +91,20 @@
         unsigned char* dest = data + ((destHeight - 1) * destWidth * 2);
         size_t destStep = destWidth * 2 * 2;
 
+       if (FT_PIXEL_MODE_MONO == bitmap.pixel_mode) {
+	  // convert the bitmap to gray map
+	  for( int y = 0; y < srcHeight; ++y)
+	  {
+	    for( int x = 0; x < srcWidth; ++x)
+	    {
+	      *dest++ = static_cast<unsigned char>(255);
+	      *dest++ = static_cast<unsigned char>((src[x >> 3] & (128 >> (x & 7))) ? 255 : 0);
+	    }
+	    dest -= destStep;
+	    src += bitmap.pitch;
+	  }
+       } else {
+
         for(int y = 0; y < srcHeight; ++y)
         {
             for(int x = 0; x < srcWidth; ++x)
@@ -100,6 +114,7 @@
             }
             dest -= destStep;
         }
+       }
 
         destHeight = srcHeight;
     }